//  Program 5.1
//  Character constants

#include <iostream.h>

void main()
{                                           // Output
  cout << 'A' << 'B' << 'C' << ' '          // ABC
       << 'a' << 'b' << 'c' << ' '          // abc
       << '1' << '2' << '3' << ' '          // 123
       << '<' << '.' << '>'                 // <.>
       << endl;
  cout << (int) '0'    << ' '               // 48
       << (int) ' '    << ' '               // 32
       << (int) 'A'    << ' '               // 65
       << (char) 48    << ' '               // 0
       << (char) 65    << ' '               // A
       << endl;

// ASCII table for 32-127 codes

  const int NRows = 32;            // Number of rows
  const int NCols =  3;            // Number of columns
  const int StartCode = 32;        // Code of blank
        int i =  0;                // Row index
        char AnyChar;

  do 
  {
    int  j = 0;                              // Column index
    do 
    {
      int Code = StartCode + i + NRows*j;    // Character code

      cout << (char) 9 << Code << '\t' << (char) Code;
    } while ( ++j < NCols );

    cout << endl;
    if ( i == NRows/2 - 1 ) 
    {
      cout << "Enter any character to continue: ";
      cin  >> AnyChar;              // Pause
    }
  } while ( ++i < NRows );

  cout << "Enter any character to continue: ";
  cin  >> AnyChar;                // Pause

// Tabs
  cout << 0                     << endl     // 0
       << '\t' << 1             << endl     //         1
       << '\t' << '\t' << 2     << endl;    //         2
  cout << "1"        <<'\t'<< 9 << endl     // 1       9
       << "123"      <<'\t'<< 9 << endl     // 123     9
       << "1234567"  <<'\t'<< 9 << endl     // 1234567 9
       << "12345678" <<'\t'<< 9 << endl;    // 12345678        9
  cout << "1"        <<'.' << 9 << endl     // 1.9
       << "123"      <<'.' << 9 << endl     // 123.9
       << "1234567"  <<'.' << 9 << endl     // 1234567.9
       << "12345678" <<'.' << 9 << endl;    // 12345678.9
  
  cout << "Column1\t\tColumn2"  << endl;
  
  cout << "\aEnter any character to continue: ";
  cin  >> AnyChar;                // Pause
  
// New line and carriage return
  
  cout << "123"        << '_'   << endl     // 123_
       << "123" << '\n' << '_'  << endl     // 123
                                            // _
       << "123" << '\r' << '_'  << endl;    // _23
  
  cout << "Line1\nLine2\n";
  
// Null character
  
  cout << 1 << '\0' << 2        << endl     // 1 2
       << sizeof ("123")        << endl;    // 4
  
// 4 special characters ' " ? \
  
  cout <<'\''<<'\"'<<'\?'<<'\\' << endl     // '"?\
       << "\' \" \? \\ "        << endl;    // ' " ? \
}