	//	Program 7.1
	//	tic-tac-toe

	#include <iostream.h>
	#include <conio.h>				//for clrscr();

	int player, row, col, winner = 0;
	char grid[3][3] = { {' ', ' ', ' '},  	//game board 3x3 initialized
			 			            {' ', ' ', ' '},	//to spaces
    						            {' ', ' ', ' '} };

	void main()
	{
		cout << "\n\n\tWelcome to the game of tic-tac-toe\n" 
			   << "\tThis is a game for two players and the computer will ask\n"
			   << "\tEach player to input their row and column number.\n"
			   << "\tThe computer shows whether the game has been won or drawn.\n";

   cout << "\n\n\tPress any key to continue .....";
   getch();                         //pause on screen - wait for key press

		for (int count = 0; count < 9 && winner == 0; count++)
		{
			clrscr();                       //clear screen

			cout << endl << endl            //display grid
				   << "\t " << grid[0][0] << " | " << grid[0][1] << " | " << grid[0][2] 
				   << " \n" << "\t-----------\n"
				   << "\t " << grid[1][0] << " | " << grid[1][1] << " | " << grid[1][2] 
				   << " \n" << "\t-----------\n"
				   << "\t " << grid[2][0] << " | " << grid[2][1] << " | " << grid[2][2] 
				   << " \n" << endl << endl;

			player = (count % 2) + 1;       //determine player

			do
			{
				do                            //check row within limits
				{
					cout << "\n\nPlayer " << player << " please enter row number: ";
					cin >> row;
				}while(row < 0 || row > 3);

				row -= 1;                     //-1 from row, to use as array index

				do
				{
					cout << "Player " << player << " please enter column number: ";
					cin >> col;
				}while(col < 0 || col > 3);   //check col within limits

				col -= 1;                     //-1 from col, to use as array index

				if(grid[row][col] == 'X' || grid[row][col] == 'O') //see if position is
					cout << "\nThis space is occupied.  Try again."; //   occupied

			}while(grid[row][col] == 'X' || grid[row][col] == 'O');  
	      //repeat loop if space occupied
	
     	grid[row][col] = (player == 1) ? 'X' : 'O';     //assign character to array
			for (int line = 0; line < 3; line++)         //check for win
			{
				if(grid[line][0] == 'X' &&  grid[line][1] == 'X' && grid[line][2] == 'X')
					winner = player;
				if(grid[line][0] == 'O' &&  grid[line][1] == 'O' && grid[line][2] == 'O')
					winner = player;
				if(grid[0][line] == 'X' &&  grid[1][line] == 'X' && grid[2][line] == 'X')
					winner = player;
				if(grid[0][line] == 'O' &&  grid[1][line] == 'O' && grid[2][line] == 'O')
					winner = player;
		 	}
		 	if(grid[0][0] == 'X' && grid[1][1] == 'X' && grid[2][2] == 'X')
				winner = player;
		 	if(grid[0][0] == 'O' && grid[1][1] == 'O' && grid[2][2] == 'O')
				winner = player;
		 	if(grid[0][2] == 'X' && grid[1][1] == 'X' && grid[2][0] == 'X')
				winner = player;
		 	if(grid[0][2] == 'O' && grid[1][1] == 'O' && grid[2][0] == 'O')
				winner = player;
		}
		clrscr();                                       //clear screen
		cout << endl << endl                            //redisplay grid
			   << "\t " << grid[0][0] << " | " << grid[0][1] << " | " 
      << grid[0][2] << " \n"
			   << "\t-----------\n"
			   << "\t " << grid[1][0] << " | " << grid[1][1] << " | " 
      << grid[1][2] << " \n"
			   << "\t-----------\n"
			   << "\t " << grid[2][0] << " | " << grid[2][1] << " | " 
      << grid[2][2] << " \n" << endl << endl;

		if(winner == 0)                                 //make announcement
			cout << "\n\nThe game is a draw";
		else
			cout << "\n\nPlayer " << player << " is the winner\n\n";
	}