//  printer.cpp
//  this program opens an existing disc file and 
//  outputs it to the printer
#include <fstream.h>      //header file needed for file input/output
#include <stdlib.h>       //header file needed for exit()

void main()
{
  const int MAX    = 20;
  const int LENGTH = 80;

  char filename[MAX];
  char buffer[LENGTH];

  cout << "\n\tThis program opens an existing disc file and "
       << "\n\toutputs the file to the printer.\n\n"
       << "Enter filename to print: ";

  cin.get(filename, MAX);

  //open file
  ifstream infile(filename);      //create file object

  if(!infile)
  {
    cerr << "\nUnable to access file.  Program terminating.\n";
    exit(-1);
  }

  ofstream printer("PRN");      //create file object

  while(infile)
  {
    //get a line
    infile.getline(buffer, LENGTH);
    //print the line
    printer << buffer << endl;
  }
}