w//      Program 9.4
//      Pointer to structure
#include "mountain.h"     // Type mountain
#include <string.h>       // for strcpy()
#include <iostream.h>

void    Say(int N, mountain M);

void main() 
{  //      Objects of type mountain
  mountain E={"Everest "};      // 0 height
  mountain M={"? "};            // Any mountain

  //      Pointers to mountain
  mountain *pE = &E;            // pE points to Everest
  mountain *pM;                 // Not initialized

  Say (1,E);                    // 1 Everest 0
  Say (2, *pE);                 // 2 Everest 0

  pM = pE;                      // pM points to Everest
  pM -> Height = 8848;          // Indirect member selector ->
  Say(3,E);                     // 3 Everest 8848

  Say(4,M);                     // 4 ? 0
  pM = &M;                      // pM now points to M
  (*pM).Height = 8848;          // Same as pM->Height=8848;
  Say(5,M);                     // 5 ? 8848

  *pM = *pE;                    // Copy structure E to M
  Say(6,M);                     // 6 Everest 8848

  strcpy(pM -> Name, "The biggest mountain");
  Say(7,M);                     // 7 The biggest mountain 8848
}

void    Say(int N, mountain M)
{
  cout    << N << ' ' << M.Name << M.Height << endl;
}

