//      Program 9.10
//      Using pointers as structure members
#include <iostream.h>
#include <iomanip.h>

struct  MOUNTAIN                               // Big MOUNTAIN
{
  char Name[21];                               // Array of chars
  int Height;
};

struct  mountain                               // Little mountain
{
  char *Name;                                  // Pointer to char
  int Height;
};

void Say(MOUNTAIN *,int);
void Say(mountain *,int);

void main() 
{
  MOUNTAIN M[]={ {"Everest", 8848},{"McKinley",6193} };
  mountain m[]={ {"Kilimanjaro",5895},{"Elbrus", 5642} };

  cout << "\nBig MOUNTAIN:\t\t" << sizeof M << ' ' 
       << sizeof (MOUNTAIN) << endl << endl;

  Say(M, sizeof M / sizeof M [0]);

  cout << "\nLittle mountain:\t" << sizeof m << ' ' 
       << sizeof (mountain) << endl << endl;

  Say(m, sizeof m / sizeof m [0]);
}

void Say(MOUNTAIN *pM,int N) 
{
  for (int i=0; i<N; i++, pM++)
    cout  << setw (20) << pM->Name << setw (6) << pM->Height << endl;
}

void Say(mountain *pM,int N) 
{
  for (int i=0; i<N; i++, pM++)
    cout  << setw (20) << pM->Name << setw (6) << pM->Height << endl;
}