//      Program 11.7
//      A static member function

#include <iostream.h>

class example
{
          int  m;
  static  int  sm;

public:
  example();                             // Constructor
  void Inc();                            // Increment m and sm
  static void Say(example&,example&);    // Say about m and sm (static)
};

//  Static member definition

int example::sm = 0;

//  Member functions

example::example() {m=0;}
void example::Inc() {m++; sm++;}

//      ------------------------------------------------------

void example::Say(example& ex1, example& ex2)
{
  cout << " ex1.m = " << ex1.m
       << " ex2.m = " << ex2.m
       <<   " sm = "  << sm << endl;

// Error: 'm' can't be used in a static member function
// cout << m;
}

//      -----------------------------------------------------

void main()
{
  example ex1,ex2;          // Use example::example(); initialize m with 0

  example::Say (ex1,ex2);      // Call static member function
  ex1.Inc ();                  // Call nonstatic member function
  example::Say (ex1,ex2);
  ex2.Inc ();
  example::Say (ex1,ex2);
}