//      Program 13.8
//      Using a pointer to a derived class

#include <iostream.h>

struct base 
{
  void Say () {cout << "Base Say()\n";}
};

struct derived : base 
{
  void Say () {cout << "Derived Say()\n";}
};

void main() 
{
  derived  D;          // Derived class object
  derived * pd;        // Pointer to derived

  pd = &D;             // pd points to D
  pd->Say();           // derived::Say()

  pd->base::Say();     // base::Say()             <--
  pd->derived::Say();  // derived::Say()
}