//  Program 13.9
//  Using a pointer to a base class

#include <iostream.h>

struct base 
{
  void Say() { cout << "Base Say()\n";} 
};

struct derived : base 
{ 
  void Say() {cout << "Derived Say()\n";} 
};


void main() 
{
  derived  D;             // Derived class object
  base *  pb;             // Pointer to base            <--
  pb = &D;          // Default conversion 'derived *' to 'base *'    <-- ! 
  pb->Say();        // base::Say(). Use POINTER type              <-- !

  pb->base::Say();        // base::Say()
  //pb->derived::Say();   // Error: 'derived' is not a base class of 'base'
}