//      Program 14.14
//      Class template - Point

#include <iostream.h>

//      Template declaration

template <class T>
class  Point 
{
  T   X;               // Two members of type T
  T   Y;
public:
  void  Set(T x,T y);  // Set X, Y values
  void  Say() {cout << "\nX = " << X << "\nY = " << Y;}
};

template <class T>                              
void Point<T>::Set (T x,T y) 
{
//      Set point coordinates
  X=x; 
  Y=y;
}

void main() 
{
  Point<int>  pi;     // Point integer        

  pi.Set (1,2);
  pi.Say ();

  Point<float>  pf;     // Point float

  pf.Set (1.1, 2.2);
  pf.Say ();
}