//  Program 16.3
//  Initialize graphics system
	
#include <iostream.h>
#include <graphics.h>                              // Graphics functions and data
#include <conio.h>                                 // getch()
	
int main()
{
//      Initialize graphics system (autodetect)
//      Load BGI driver and set graphics mode
	
  int Driver=DETECT;              // Driver to be used (autodetect it) 
  int Mode;                       // Screen mode (returned)
  char *  Path = "";              // Path to driver (current directory)
                                  // Enter the path to your BGI directory
  initgraph (&Driver, &Mode, Path);
	
  int InitRes;

  InitRes = graphresult();        // Get result of initialization
  if (InitRes != grOk) 
  {
    cout  << "Graphics Error: " << grapherrormsg (InitRes);
    return 1;
  }
	
  cout << "Hello, Programmer!" << "\n\nThe graphics driver " 
																	<< getdrivername ()
       << "\nand graphics mode " << getmodename (Mode) 
       << "\nare used.\n\nPress any key...";

  getch ();                       // Wait for key pressed

  closegraph ();                  // Restore previous screen mode
}