//  Program 16.4
//  Displaying dot (pixel)
	
#include "P16-04.h"
	
int main()
{
  if (! Init ())                // Initialize graphics system
    return 1;                   // Exit on error

//      Maximum x, y coordinates and color values
  const int MaxX     = getmaxx ();
  const int MaxY     = getmaxy ();
  const int MaxColor = getmaxcolor ();
	
  cout << "\n Max X     = " << MaxX << "\n Max Y     = " << MaxY
       << "\n Max Color = " << MaxColor;

  Pause();                      // Wait for key to be pressed
	
  // putpixel ()
  cleardevice ();               // Clear screen
	
  int X=0, Y=0;                 // x, y coordinates
  int C = MaxColor;             // Color

  putpixel (X,Y,C);             // Pixel 1 at the left top corner
  Pause ();
	
  X = MaxX/2; Y=0;
  putpixel (X,Y,C);             // Pixel 2 at the center top
  Pause ();
	
  X=0;
  Y=MaxY/2;
  putpixel (X,Y,C);             // Pixel 3 at the left center
  Pause ();

  X=MaxX/2;   
  Y=MaxY/2;
  putpixel (X,Y,C);             // Pixel 4 at the screen center
  Pause ();
	
  closegraph ();
}
