//  strings.cpp
//a program to manipulate strings  

#include <iostream.h>    //header file for Input/Output

void main()
{
  const int MAX = 81;
  int counter;
  char string1[MAX], string2[MAX];

  //function prototypes
  int length(char str[]);  
      //function to find length of string
  void copy(char * source, char * dest);
      //function to copy string
  void reverse(char * str);
      //function to reverse string
  int LocateChar(char str[], char ch);  
      //function to find first occurrence of a character

  cout << "\n\n\tThis program manipulates strings.\n\n"
             << "\tEnter a string with a maximum of 80 characters\n\t";

  cin.get(string1, MAX);
      //this function is used to input string
      //cin on its own would stop at first white space

  cout << "\n\tYou entered: " << string1 << endl;

  cout << "\tThe string is " << length(string1) 
       << " characters long\n";

  cout << "\tCopying string1 to string2 ... \n";

  copy(string1, string2);

  cout << "\tstring2 contains: " << string2 << endl;

  int result = LocateChar(string1, 'a');
  if(result == -1)
     cout << "\tThe character was not found in the string\n";
  else
     cout << "\tThe first occurrence of the letter 'a' is element "
          << LocateChar(string1, 'a') << endl;

  reverse(string1);

  cout << "\tstring1 has been reversed and now reads ... \n\t"
            << string1;
}

int length(char str[])
{
  int number = 0;           //initialize variable to 0
while(str[number] != '\0')  //look for the null character
  number++;                 //if not found increment count
return(number);             //return number of characters
}

void copy(char * source, char * dest)
{
  while(*dest++ = *source++);
}

void reverse(char * str)
{
  int count1 = 0, count2 = length(str) - 1;
const int SIZE = 81;
char letter[SIZE];        //temporary string

while(count2 > -1)
  letter[count1++] = str[count2--];   
                               //assign last letter of str as first of letter
letter[count1++] = '\0';       //insert null character
copy(letter, str);
                               //copy temporary string to our variable
}

int LocateChar(char str[], char ch)
{
  int number = 0;

while(str[number] != '\0')    //look for null character
{                             //if not found ...
  if(str[number] == ch)       //if character located
    return(number + 1);       //return its position
  else
    number++;    
                              //if character not located increment counter
}
return(-1);                   //return -1 to signify character not found
}