//  Program 8.10
//  writing to a binary file
#include <stdlib.h>
#include <fstream.h>

void main()
{
  ofstream output("binary1.out", ios::binary );
  if(!output)
  {
    cout << "\n\n\tCouldn't Open File\n";
    exit(-1);
  }
  char text1[80] = "\n\tThe Beginners Guide to C++\n";
  char text2[80] = "\tby Oleg Yarosh";
  char text3[80] = "\n\n\tPublished by Wrox Press Ltd, 1994\n";

  output.write((char *) &text1, sizeof(text1));
  output.write((char *) &text2, sizeof(text2));

  for (int i = 0; i < sizeof(text3); i++)
    output.put(text3[i]);
  for (i = 0; i < 256; i++)
    output.put((char) i);
  output.close();
}