//  Program 8.12
//  copying a file  
#include <stdlib.h>
#include <fstream.h>

void main()
{
  ifstream input1("binary1.out", ios::app | ios::binary );
  ifstream input2("file8.cpp", ios::app);
  ofstream output1("binary1.cpy", ios::binary);
  ofstream output2("file8.cpy");

  if(!input1)
    cout << "\n\n\tCouldn't Open Input1\n";
  if(!input2)
    cout << "\n\n\tCouldn't Open Input2\n";
  if(!output1)
  {
    cout << "\n\n\tCouldn't Open Output1\n";
    exit(-1);
  }
  if(!output2)
  {
    cout << "\n\n\tCouldn't Open Output2\n";
    exit(-1);
  }

  while(!input1.eof())
  {
    char ch;
    input1.get(ch);
    output1 << ch;
  }
  input1.close();
  output1.close();
  while(!input2.eof())
  {
    char buffer[120];
    input2.getline(buffer, 120);
    output2 << buffer << endl;
  }
  input2.close();
  output2.close();
}