//  Program 8.15
//  moving the file pointer from A to Z
#include <stdlib.h>
#include <fstream.h>
#include <iomanip.h>

void main()
{
  ofstream output("p08_15.dat", ios::binary);
  long FP;
  char ch;

  if(!output)
  {
    cout << "\n\n\tCouldn't Open file\n";
    exit(-1);
  }

  char line[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  output << line;
  output.close();
  cout << "Moving file pointer in p08-17.dat...\n\n";

  ifstream input("p08_15.dat", ios::binary);
  input.seekg(0, ios::beg);
  FP = input.tellg();
  input >> ch;

  cout << "First byte " << ch << " " << (int) ch
       << " at file pointer " << FP << endl;

  input.seekg(-1, ios::end);
  FP = input.tellg();
  input.read((char *) &ch, sizeof(ch));

  cout << "Last byte " << ch << " " << (int) ch
       << " at file pointer " << FP << endl;

  input.seekg(0, ios::cur);
  FP = input.tellg();
  input.get(ch);

  cout << "EOF byte " << ch << " " << (int) ch
       << " at file pointer " << FP << endl;
  input.close();
}