//      Program 10.7
//      4 overloaded constructors

#include <iostream.h>
#include <string.h>

struct mountain 
{
  char Name[21];
  int Height;
// init () is called from constructors
  void init(char* N,int H) 
  {
    strcpy (Name,N);
    Height = H;
  }

// 4 constructors
  mountain();      // Default (without arguments)
  mountain(int);
  mountain(char*);
  mountain(char*,int);
};

void main()
{
                        // Output
  mountain M0;          // Using default constructor
  mountain M1(0);       // Using int-constructor
  mountain M2("");      // Using char-constructor
  mountain M3("",0);    // Using char-int-constructor
}

//  Definition of default constructor
mountain::mountain() 
{
  init("",0);
  cout << "Using default constructor\n";
}

//  Definition of constructor with one int argument
mountain::mountain(int H) 
{
  init("",H);
  cout << "Using int-constructor\n";
}

//  Definition of constructor with one char argument
mountain::mountain(char* N) 
{
  init(N,0);
  cout << "Using char-constructor\n";
}

// Definition of constructor with both types of argument
mountain::mountain(char* N,int H) 
{
  init(N,H);
  cout << "Using char-int-constructor\n";
}