//      Program 10.13
//      Illegal usage of a pointer to an object which has been destroyed

#include <iostream.h>

//      Type declaration
struct  s 
{
  int m;      // Data member
  s();        // Constructor
  ~s();       // Destructor
};

//      Constructor and destructor definitions
s :: s() 
{
  cout << "Constructing local structure S\n"; 
  m=1;
}

s ::~s() 
{
  cout << "Destroying local structure S\n";
}

s * any_function() 
{
  cout << "Starting any_function ()\n";

  s  S;              // Automatic structure
  s *  pS = &S;      // pS points to S

  cout << "Displaying value of local structure member pS->m: " << pS->m 
				<< endl;
  cout << "Returning pointer pS from any_function()\n";

  return pS;
  //      Destructor ~s() is called just AFTER exit
}

void main() 
{
  s *  pS;

  cout << "Starting main()\n";
  cout << "Calling any_function ()\n";

  pS = any_function();

  cout << "Returning to main()\n";

/*      Now pS points to an automatic variable in any_function (),
        the structure S whose value is destroyed by the destructor
        It is illegal to use a pointer to such objects
*/
  cout << "Displaying value of destroyed structure member pS->m: "      
				<< pS->m << endl;

  cout << "Ending main ()\n";
}