//     Program 11.3
//     Member function - a friend of another class

#include <iostream.h>
#include <string.h>

class continent;

class mountain
{
  char N[21];

public:
  mountain (char *);
  void Say(continent&);    // Member function (continent class friend)
};

class continent
{  // Friend function of this class 
  friend void mountain::Say(continent&);  
  char N[21];

public:
  continent (char *);
};

//      Constructors definitions

  mountain::mountain(char * N) {strcpy (mountain::N,N);}
  continent::continent(char * N) {strcpy (continent::N,N);}

//      ------------------------------------------------------

void mountain::Say(continent& C)
{
/*  Say about a mountain and a continent

    mountain class member function, which is a friend of the class 				continent, can access all continent class members
*/

  cout << N << C.N << endl;
}

//      ------------------------------------------------------

void main()
{

  mountain E = "Everest ";
  continent C = "Asia ";

  E.Say (C);             // Call class mountain member function,
                         // which is a friend of the class continent
}