//      Program 11.4
//      Strange friendship of two classes

#include <iostream.h>
#include <string.h>

// Classes
class mountain
{  // The class continent is a friend of the class mountain 
  friend class continent; 

  char N [21];
public:
  mountain (char *);
  void Say(continent&);
};

class continent
{
  //friend class mountain;
  // Class mountain isn't a friend of class continent !!!
  char N[21];
public:
  continent (char *);
  void Say(mountain&);
};

//      Constructors definitions
  mountain::mountain (char * N) {strcpy (mountain::N,N);}
  continent::continent (char * N) {strcpy (continent::N,N);}

//      ------------------------------------------------------

void continent::Say(mountain& M)
{
/*      Say about a mountain and a continent

  continent class member function, which is a friend of class mountain,
  can access all mountain class members
*/
  cout << M.N << N << endl;
}

//      ------------------------------------------------------

void mountain::Say(continent& C)
{  //  Say about a mountain 

  cout << N
  //   << C.N      // Error: "continent::N" isn't accessible
                   // Class mountain isn't a friend of the class continent,
                   // so the class mountain member function mountain::Say()
                   // can't access the class continent member continent::N
       << endl;
}

//      ------------------------------------------------------

void main ()
{
  mountain E = "Everest ";
  continent C = "Asia ";

  E.Say (C);
  C.Say (E);
}