//      Program 11.6
//      Static data member definition is required somewhere

#include <iostream.h>

//  Declarations

struct nonStaticStruct {       char C;}; // Non static
struct staticStruct    {static char C;}; // Static

//  Static member definition (global)

char staticStruct::C =  'C'; // Static member C of staticStruct is defined

//  Class objects definitions (global)

nonStaticStruct N1 = {'A'};              // N1.C is defined
nonStaticStruct N2 = {'B'};              // N2.C is defined
staticStruct S1;                         // No member S1.C is defined   <--
staticStruct S2;                         // No member S2.C is defined   <--

//      ------------------------------------------------------

void main()
{                                    // Output
  cout << N1.C << endl               // A
       << N2.C << endl               // B
       << staticStruct::C << endl    // C
       << S1.C << endl               // C
       << S2.C << endl;              // C
}