//     Program 12.5
//     Adding with a friend function

#include <iostream.h>

class number
{
  int n;      // Private member
public:
         number() {n = 1;}
  friend number& operator+ (number&,number&);
         void Say ();
};

number T;      // Temporary object (global)

number& operator+ (number& N1,number& N2)
{
/*      operator+() a friend function of the class number

    Adds two objects of type number
    and stores the result in a temporary object (global).
    Returns the reference to the temporary object.
*/

  T.n = N1.n + N2.n;
  return  T;
}

void number::Say ()
{
  cout << ' ' << n << ' ';
}

void main ()
{
  number  X,Y,Z = X + Y;
                   //output
  X.Say();         // 1 
  cout << '+';     // +
  Y.Say();         // 1
  cout << '=';     // =
  Z.Say();         // 2

  // cout << Z;    // Error: operator << cannot be applied
                   // to operand of type number
}