//  Program 12.6
//  Displaying numbers

#include <iostream.h>

class number
{
  int n;       // Private member
public:
        number() {n = 1;}
  friend number&  operator+  (number&,number&);
  friend ostream& operator<< (ostream&,number&);
};

number T;       // Temporary object (global)

number& operator+ (number& N1,number& N2)
{
/*     operator+() friend function of class number

  Adds two objects of type number
  and stores the result into a global temporary
  object. Returns the reference to the temporary
  object.
*/

  T.n = N1.n + N2.n;
  return  T;
}

ostream& operator<< (ostream& Cout,number& N)
{
/*      operator<<() friend function of class number
        and public member function of class ostream

  Inserts N.n into stream Cout (global)
  Returns reference to Cout
*/

  Cout << ' ' << N.n << ' ';
  return Cout;
}

void main()
{
  number  X,Y,Z = X + Y;

  cout << X << '+' << Y << '='<< Z;      // 1 + 1 = 2
}