//     Program 13.19
//     Multiple inheritance and virtual functions

#include <iostream.h>

struct coordinate {int N; virtual void Say(); };
struct x_coord : coordinate {void Say(); };
struct point : x_coord {void Say(); };

void coordinate::Say() { cout << N << " coordinate::N\n"; }
void x_coord::Say() { cout << N << " x_coord::N\n"; }
void point::Say() { cout << N << " point::N\n"; }

void Say(coordinate & C) { C.Say(); }

void main() 
{
  coordinate C;                        // Define objects
  x_coord X; 
  point P;

  C.N     = 1;                         // Set values
  X.N     = 2;
  P.N     = 3;

  Say(C);                              // Display N
  Say (X);
  Say (P);

//      Any derived class with Say() function
  struct any : point { void Say() {cout << N << " any::N\n";} };

  any A;                            // Define object of new derived class

  A.N     = 4; 
  Say(A);                           // Ok
}