// Program 16.6
// Draw bar

#include "h:\books\265\ch16\progs.imw\P16-04.h"

int main()
{
  if (! Init ())          // Initialize graphics system
    return 1;             // Exit on error

  const int MaxX    = getmaxx();
  const int MaxY    = getmaxy();
  const int MaxColor = getmaxcolor();

//      Draw bar with putpixel ()

  int Color = MaxColor, 
      X, Y = 0,           // Loop variables
      X1=0, Y1=0,         // Left top corner
      X2=MaxX, Y2=MaxY;   // Right bottom corner

  for  ( X = X1; X <= X2; X++)
    for (Y = Y1; Y <= Y2; Y++)
      putpixel (X,Y,Color);       // Output dot at X,Y
  Pause ();

//      Draw bar with line ()

  setcolor(getbkcolor());        // Set background color

  X1+=5;
  Y1+=5;                         // Adjust bar
  X2-=5;  
  Y2-=5;

  for  ( X = X1; X <= X2; X++)
    line (X,Y1,X,Y2);            // Draw vertical line
  Pause ();

//      Draw bar with bar ()

  X1+=5;
  Y1+=5;                         // Adjust bar
  X2-=5;
  Y2-=5;

  int FillColor = Color;

  setfillstyle (SOLID_FILL,FillColor);    // Set fill color
  bar (X1,Y1,X2,Y2);              // Draw bar (not outlined) 
  Pause ();

  closegraph ();
}