//  Program 16.7
//  Draw text

#include "h:\books\265\ch16\progs.imw\P16-04.h"

int main()
{
  if (! Init ())          // Initialize graphics system
    return 1;             // Exit on error

  const int MaxX    = getmaxx ();
  const int MaxY    = getmaxy ();
  const int MaxColor = getmaxcolor ();

//      Output text

  int X, Y, Color = MaxColor;

  setcolor(Color);        // Set draw color
  outtext ("A");          // Output text at CP (0,0)
  Pause ();
  outtext ("B");          // Output 'B' after 'A'
  Pause ();

  X=MaxX/4, Y=MaxY/4;
  outtextxy (X,Y,"of");   // Output text at X,Y
  Pause ();

  outtext ("C");          // Output 'C' after 'B', not after 'of' 
  Pause ();

//      Change font

  int Font = TRIPLEX_FONT, Direction = HORIZ_DIR, Size = 1;

  X=MaxX/2, Y=MaxY/2;                     // Move CP to the
  moveto (X,Y);                           // screen center

  settextstyle (Font,Direction,Size);

  outtext ("BGI text output");
  Pause ();

//      Clear text

  Color = getbkcolor();
  setcolor(Color);              // Set background draw color moveto (X,Y);
  outtext("BGI text output");   // Clear
  Pause ();

//      New text at the same place

  setcolor (MaxColor);
  outtextxy (X,Y,"C++");
  Pause ();

  closegraph ();
}
